#include "prjlibs-c/standards.h"
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

#include "skalibs/include/stddjb.h"
#include "prjlibs-c/package_home.h"
#include "prjlibs-c/constants.h"
#include "prjlibs-c/diewarn.h"
#include "svclean.h"

char const* PROG="svclean-svscan";

int main(int argc, char** argv) {
  int logpipe[2];

  if (argc<2) DIE_USAGE(" svscan [/service]");

  MUST_CLOSE(FILENO_PIPERD);

  if ((dup2(STDOUT_FILENO, FILENO_NEWOUT)!=FILENO_NEWOUT && errno!=EBADF) ||
      (dup2(STDERR_FILENO, FILENO_NEWERR)!=FILENO_NEWERR && errno!=EBADF))
    DIE0(dup2);
  buffer_2->fd=FILENO_NEWERR;

  MUST_CLOSE(STDOUT_FILENO);
  MUST_CLOSE(STDERR_FILENO);

  if (pipe(logpipe)!=0) DIE0(pipe);
  if (ndelay_on(logpipe[PIPE_WR])==-1) DIE1(setfl, "log pipe");

  if (logpipe[PIPE_WR]==FILENO_PIPERD) {
    int wr0, wr1;
    if (logpipe[PIPE_RD]==STDOUT_FILENO) {
      wr0=STDERR_FILENO;
      wr1=STDOUT_FILENO;
    } else {
      wr0=STDOUT_FILENO;
      wr1=STDERR_FILENO;
    }
    if (dup2(logpipe[PIPE_WR], wr0)!=wr0) DIE0(dup2);
    if (dup2(logpipe[PIPE_RD], FILENO_PIPERD)!=FILENO_PIPERD) DIE0(dup2);
    if (fd_close(logpipe[PIPE_RD])!=0) DIE1(close, "log pipe");
    if (dup2(wr0, wr1)!=wr1) DIE0(dup2);
  } else {
    if (logpipe[PIPE_RD]!=FILENO_PIPERD) {
      if (dup2(logpipe[PIPE_RD], FILENO_PIPERD)!=FILENO_PIPERD) DIE0(dup2);
      if (fd_close(logpipe[PIPE_RD])!=0) DIE1(close, "log pipe");
    }
    if (logpipe[PIPE_WR]==STDOUT_FILENO) {
      if (dup2(logpipe[PIPE_WR], STDERR_FILENO)!=STDERR_FILENO) DIE0(dup2);
    } else {
      if (dup2(logpipe[PIPE_WR], STDOUT_FILENO)!=STDOUT_FILENO) DIE0(dup2);
      if (logpipe[PIPE_WR]!=STDERR_FILENO) {
        if (fd_close(logpipe[PIPE_WR])!=0) DIE1(close, "log pipe");
        if (dup2(STDOUT_FILENO, STDERR_FILENO)!=STDERR_FILENO) DIE0(dup2);
      }
    }
  }

  if (pathexec_env("SUPERVISE_PATH", env_get("PATH"))==0) DIE0(alloc);
  if (pathexec_env("PATH", PACKAGE_HOME "/libexec")==0) DIE0(alloc);

  ++argv;
  pathexec((char const**)argv);
  DIE1(exec, argv[0]);
}
